import { AfterContentInit, ChangeDetectorRef, ElementRef, EventEmitter, ModuleWithProviders, QueryList } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { MdlPopoverComponent } from '../popover/index';
import { MdlOptionComponent } from './option';
export declare class SearchableComponent {
    private clearTimeout;
    private query;
    private searchTimeout;
    constructor(searchTimeout?: number);
    protected updateSearchQuery(event: any): void;
    protected getSearchQuery(): string;
}
export declare class MdlSelectComponent extends SearchableComponent implements ControlValueAccessor, AfterContentInit {
    private changeDetectionRef;
    ngModel: any;
    disabled: boolean;
    autocomplete: boolean;
    label: string;
    isFloatingLabel: boolean;
    placeholder: string;
    multiple: boolean;
    change: EventEmitter<any>;
    inputChange: EventEmitter<any>;
    selectInput: ElementRef;
    popoverComponent: MdlPopoverComponent;
    optionComponents: QueryList<MdlOptionComponent>;
    private _isFloatingLabel;
    textfieldId: string;
    text: string;
    private textByValue;
    private onChange;
    private onTouched;
    focused: boolean;
    constructor(changeDetectionRef: ChangeDetectorRef);
    ngAfterContentInit(): void;
    onKeydown($event: KeyboardEvent): void;
    onInputBlur(): void;
    isDirty(): boolean;
    onInputChange($event: Event): void;
    private onCharacterKeydown($event);
    private getAutoSelection();
    private onArrowUp($event);
    private onArrowDown($event);
    addFocus(): void;
    removeFocus(): void;
    private isEmpty();
    reset(resetValue?: boolean): void;
    private bindOptions();
    private renderValue(value);
    private stringifyValue(value);
    toggle($event: Event): void;
    open($event: Event): void;
    close($event: Event): void;
    private onSelect($event, value);
    writeValue(value: any): void;
    registerOnChange(fn: (value: any) => void): void;
    registerOnTouched(fn: () => {}): void;
    setDisabledState(isDisabled: boolean): void;
}
export declare class MdlSelectModule {
    static forRoot(): ModuleWithProviders;
}
